/*-----------------------------------------------------------------------*/
/* Low level disk I/O module SKELETON for FatFs     (C)ChaN, 2019        */
/*-----------------------------------------------------------------------*/
/* If a working storage control module is available, it should be        */
/* attached to the FatFs via a glue function rather than modifying it.   */
/* This is an example of glue functions to attach various exsisting      */
/* storage control modules to the FatFs module with a defined API.       */
/*-----------------------------------------------------------------------*/

#include "ff.h"			/* Obtains integer types */
#include "diskio.h"		/* Declarations of disk functions */

#include <stdio.h>

#include "main.h"
#include "stm32f4xx_hal.h"

/*-----------------------------------------------------------------------*/
/* Get Drive Status                                                      */
/*-----------------------------------------------------------------------*/

DSTATUS disk_status (
	BYTE pdrv		/* Physical drive nmuber to identify the drive */
)
{
  DSTATUS stat = STA_NOINIT;

  HAL_StatusTypeDef card_result = HAL_SD_GetCardState(&hsd);
  
  if(card_result == HAL_SD_CARD_TRANSFER) {
    stat &= ~STA_NOINIT;
  }
  
  // printf("card stat: %d\n", card_result);
  return stat;
}


/*-----------------------------------------------------------------------*/
/* Inidialize a Drive                                                    */
/*-----------------------------------------------------------------------*/

DSTATUS disk_initialize (
	BYTE pdrv				/* Physical drive nmuber to identify the drive */
)
{
  DSTATUS stat = STA_NOINIT;

  HAL_StatusTypeDef init_result = HAL_SD_InitCard(&hsd);
  
  if (init_result == HAL_OK) {
    stat &= ~STA_NOINIT;
  }

  // printf("card init: %d\n", init_result);
  return stat;
}


/*-----------------------------------------------------------------------*/
/* Read Sector(s)                                                        */
/*-----------------------------------------------------------------------*/

DRESULT disk_read (
	BYTE pdrv,		/* Physical drive nmuber to identify the drive */
	BYTE *buff,		/* Data buffer to store read data */
	LBA_t sector,	/* Start sector in LBA */
	UINT count		/* Number of sectors to read */
)
{
	DRESULT res = RES_OK;
  uint32_t timeout = 100000;
  
  HAL_StatusTypeDef read_result = HAL_SD_ReadBlocks(&hsd, buff, sector, count, 500);
  
  if (read_result == HAL_OK) {
    while(HAL_SD_GetCardState(&hsd) != HAL_SD_CARD_TRANSFER) { //wait busy
      timeout --;
      if (timeout == 0) {
        res = RES_ERROR;
      }
    }
  } else {
    res = RES_ERROR;
  }
  
  // printf("card read %d block%s @ %d: %d\n", count, count == 1 ? "" : "s", sector, read_result);
	return res;
}


/*-----------------------------------------------------------------------*/
/* Write Sector(s)                                                       */
/*-----------------------------------------------------------------------*/

#if FF_FS_READONLY == 0

DRESULT disk_write (
	BYTE pdrv,			/* Physical drive nmuber to identify the drive */
	const BYTE *buff,	/* Data to be written */
	LBA_t sector,		/* Start sector in LBA */
	UINT count			/* Number of sectors to write */
)
{
	DRESULT res = RES_OK;
  uint32_t timeout = 100000;
  
  HAL_StatusTypeDef write_result = HAL_SD_WriteBlocks(&hsd, (uint8_t *)buff, sector, count, 500);
  
  if (write_result == HAL_OK) {
    while(HAL_SD_GetCardState(&hsd) != HAL_SD_CARD_TRANSFER) { //wait busy
      timeout --;
      if (timeout == 0) {
        res = RES_ERROR;
      }
    }
  } else {
    res = RES_ERROR;
  }
  
  // printf("card write %d block%s @ %d: %d\n", count, count == 1 ? "" : "s", sector, write_result);
	return res;
}

#endif


/*-----------------------------------------------------------------------*/
/* Miscellaneous Functions                                               */
/*-----------------------------------------------------------------------*/

DRESULT disk_ioctl (
	BYTE pdrv,		/* Physical drive nmuber (0..) */
	BYTE cmd,		/* Control code */
	void *buff		/* Buffer to send/receive control data */
)
{
  DRESULT res = RES_ERROR;
  HAL_SD_CardInfoTypeDef card_info;
  
  switch (cmd) {
  /* Make sure that no pending write process */
  case CTRL_SYNC:
    res = RES_OK;
    break;
  
  /* Get number of sectors on the disk (DWORD) */
  case GET_SECTOR_COUNT:
    HAL_SD_GetCardInfo(&hsd, &card_info);
    *(DWORD *)buff = card_info.LogBlockNbr;
    res = RES_OK;
    break;
  
  /* Get R/W sector size (WORD) */
  case GET_SECTOR_SIZE:
  /* Get erase block size in unit of sector (DWORD) */
  case GET_BLOCK_SIZE:
    HAL_SD_GetCardInfo(&hsd, &card_info);
    *(WORD *)buff = card_info.LogBlockSize;
    res = RES_OK;
    break;
  
  default:
    res = RES_PARERR;
  }
  return res;
}

